import React, { useState, useEffect, } from "react";
import { useForm } from "react-hook-form";
import { getCookie, setCookie } from 'react-use-cookie';
import Box from '@mui/material/Box';
import { useParams } from 'react-router-dom'
import { Helmet } from "react-helmet";
import Footer from "./Fotter";
import Header from "./Header";
import { Button, } from "reactstrap";
import axios from "axios";
import TextField from '@mui/material/TextField';
import MenuItem from '@mui/material/MenuItem';
import { AiOutlineEdit } from "react-icons/ai";
import { FcCancel, FcApproval, FcAcceptDatabase } from "react-icons/fc";
import { DataGrid, GridToolbar, frFR, GridCellParams } from '@mui/x-data-grid';
import Popup from 'reactjs-popup';
import 'reactjs-popup/dist/index.css';
import DatePicker from "react-datepicker";
import "react-datepicker/dist/react-datepicker.css";
import setHours from "date-fns/setHours";
import setMinutes from "date-fns/setMinutes";
import ToggleSwitch from "./ToggleSwitch";
import { format } from 'date-fns'
import moment from "moment";
import fileDownload from 'js-file-download'
import { ConsoleView } from "react-device-detect";
import { confirmAlert } from 'react-confirm-alert';

function GestionAdministrative(props) {

    const { internal_url } = useParams();
    const [mypresence, setmypresence] = useState("");
    const [mypublished, setmypublished] = useState("");
    const [mydistance, setmydistance] = useState("");

    const [classtitle, setclasstitle] = useState("");

    const columns_preinscrit = [
        { field: 'id', headerName: 'id', hide: true },
        { field: 'email', headerName: 'email', width: 200, hideable: false, flex: 1 },
        { field: 'nom', headerName: 'nom', width: 150, hide: false, editable: true },
        { field: 'prenom', headerName: 'prenom', width: 150, hide: false, editable: true },
        { field: 'employeur', headerName: 'Employeur', width: 200, hide: false, editable: true },
        { field: 'opco', headerName: 'Centre Opco', width: 150, hide: false, editable: true },
        { field: 'modefinancement', headerName: 'Financement', width: 150, hide: false, editable: true },
        { field: 'amount', headerName: 'Montant Formation', width: 150, type: 'number', hideable: false, flex: 1, editable: true },
        {
            field: "update", headerName: 'Mise à jour',
            renderCell: (cellValues) => {
                return (

                    <Popup
                        trigger={<Button

                            onClick={(event) => {
                                handleClick_accept(event, cellValues);
                            }}
                        >
                            <FcAcceptDatabase />

                        </Button>}
                        modal
                        nested
                        position="center center"
                    >
                        {close => (
                            <div>
                                <button className="gest_close" onClick={close}>
                                    &times;
                                </button>
                                <div className="gest_header"> MySy Info </div>
                                <div className="gest_content">
                                    {' '}

                                    Confirmer la mise à jour des informations du stagiaire
                                </div>
                                <div className="gest_actions">
                                    <div style={{ "width": "45%", "float": "left" }}>
                                        <button className="gest_bton_popup" onClick={(event) => {
                                            handleClick_update_data(event, cellValues);
                                            close();
                                        }}> Valider </button>

                                    </div>
                                    <div style={{ "width": "45%", "float": "right" }}>
                                        <button
                                            className="gest_bton_popup"
                                            onClick={() => {
                                                console.log('modal closed ');
                                                close();
                                            }}
                                        >
                                            Annuler
                                        </button>
                                    </div>
                                </div>
                            </div>
                        )}
                    </Popup>

                );
            }
        },

        {
            field: "valide", headerName: 'Valider',
            renderCell: (cellValues) => {
                return (

                    <Popup
                        trigger={<Button

                            onClick={(event) => {
                                handleClick_accept(event, cellValues);
                            }}
                        >
                            <FcApproval />

                        </Button>}
                        modal
                        nested
                        position="center center"
                    >
                        {close => (
                            <div>
                                <button className="gest_close" onClick={close}>
                                    &times;
                                </button>
                                <div className="gest_header"> MySy Info </div>
                                <div className="gest_content">
                                    {' '}

                                    En confirmant cette opération, l'inscription du stagiaire sera définitivement validée. <br />
                                    Il (le stagiaire) sera automatiquement notifié par email de la validation de son inscription. <br />
                                    Le stagiaire passera de l'onglet "préinscrit" vers l'onglet "inscription".<br />
                                </div>
                                <div className="gest_actions">
                                    <div style={{ "width": "45%", "float": "left" }}>
                                        <button className="gest_bton_popup" onClick={(event) => {
                                            handleClick_accept(event, cellValues);
                                            console.log('modal closed ');
                                            close();
                                        }}> Valider </button>

                                    </div>
                                    <div style={{ "width": "45%", "float": "right" }}>
                                        <button
                                            className="gest_bton_popup"
                                            onClick={() => {
                                                console.log('modal closed ');
                                                close();
                                            }}
                                        >
                                            Annuler
                                        </button>
                                    </div>
                                </div>
                            </div>
                        )}
                    </Popup>

                );
            }
        },

        {
            field: "refuse", headerName: 'Refuser',
            renderCell: (cellValues) => {
                return (

                    <Popup trigger={<Button

                        onClick={(event) => {
                            handleClick_refuse(event, cellValues);
                        }}
                    >
                        <FcCancel />

                    </Button>}
                        position="center" >
                        <div style={{ "width": "5rem", "height": "5rem" }}>
                            lksqmkdsmkdsm
                        </div>
                    </Popup>

                );
            }
        }


    ]

    const columns_inscrit = [
        { field: 'id', headerName: 'id', hide: true },
        { field: 'email', headerName: 'emails', width: 200, hideable: false, flex: 1, minWidth: 150, maxWidth: 300 },
        { field: 'nom', headerName: 'nom', width: 150, hide: false, editable: true, resizable: true },
        { field: 'prenom', headerName: 'prenom', width: 150, hide: false, editable: true },
        { field: 'employeur', headerName: 'Employeur', width: 200, hide: false, editable: true },
        { field: 'opco', headerName: 'Centre Opco', width: 150, hide: false, editable: true },
        { field: 'modefinancement', headerName: 'Financement', width: 150, hide: false, editable: true },
        { field: 'amount', headerName: 'Montant Formation', width: 150, type: 'number', hideable: false, flex: 1, editable: true },
        {
            field: "sendmail", headerName: 'Email Confirmation',
            renderCell: (cellValues) => {
                return (

                    <Button

                        onClick={(event) => {
                            handleClick_resend_conf_mail(event, cellValues);
                        }}
                    >
                        <FcApproval />

                    </Button>

                );
            }
        },
        {
            field: "valide", headerName: 'Valider',
            renderCell: (cellValues) => {
                return (

                    <Button

                        onClick={(event) => {
                            handleClick_accept(event, cellValues);
                        }}
                    >
                        <FcApproval />

                    </Button>

                );
            }
        },

        {
            field: "refuse", headerName: 'Refuser',
            renderCell: (cellValues) => {
                return (

                    <Popup trigger={<Button

                        onClick={(event) => {
                            handleClick_refuse(event, cellValues);
                        }}
                    >
                        <FcCancel />

                    </Button>}
                        position="center" >
                        <div style={{ "width": "5rem", "height": "5rem" }}>
                            lksqmkdsmkdsm
                        </div>
                    </Popup>

                );
            }
        },




    ]

    const columns_list_emargement = [
        { field: 'id', headerName: 'id', hide: true },
        { field: 'date', headerName: 'date', width: 100, hideable: false, flex: 1 },
        { field: 'email', headerName: 'email', width: 250, hideable: false, flex: 1 },
        { field: 'nom', headerName: 'nom', width: 150, hide: false, editable: true },
        { field: 'prenom', headerName: 'prenom', width: 150, hide: false, editable: false },
        { field: 'matin', headerName: 'Matin', width: 100, hide: false, editable: true, type: 'boolean', },
        { field: 'apresmidi', headerName: 'Apres midi', width: 100, hide: false, editable: true, type: 'boolean', },
        {
            field: "valide", headerName: 'Valider',
            renderCell: (cellValues) => {
                return (

                    <Button

                        onClick={(event) => {
                            handleClick_valide_emargement(event, cellValues);
                        }}
                    >
                        <FcApproval />

                    </Button>

                );
            }
        },

    ]
    const [UpdateStagiaireEmargement_api, setUpdateStagiaireEmargement_api] = useState();
    const [UpdateStagiaireEmargement_message, setUpdateStagiaireEmargement_message] = useState();
    const [UpdateStagiaireEmargement_result, setUpdateStagiaireEmargement_result] = useState();
    function handleClick_valide_emargement(event, cellValues) {

        var date = cellValues.row.date;
        var email = cellValues.row.email;
        var matin = cellValues.row.matin;
        var matin_val = "";
        var apresmidi = cellValues.row.apresmidi;
        var apresmidi_val = "";

        if (matin === true) {
            matin_val = "1"
        } else if (matin === false) {
            matin_val = "0"
        }

        if (apresmidi === true) {
            apresmidi_val = "1"
        } else if (apresmidi === false) {
            apresmidi_val = "0"
        }
        console.log(" ### date , email, matin,matin_val,  apresmidi, apresmidi_val = ",
            date, email, matin, matin_val, apresmidi, apresmidi_val);

        var form = new FormData();
        //form.append("token","K3cw63eKokKSbV4spjQ48SUNnfy80yrXfA");
        const stored_cookie = getCookie('tokenmysypart');
        form.append("token", stored_cookie);
        form.append("session_id", mysession);
        form.append("email", email);
        form.append("date", date);
        form.append("matin", matin_val);
        form.append("apresmidi", apresmidi_val);


        var myurl = process.env.REACT_APP_API_URL + "myclass/api/UpdateUserEmargementDate/";
        axios.post(myurl, form).then(res => {

            if (String(res.data.status) !== "false") {
                //console.log(" In UpdateStagiaireData  res.data.status = " + res.data.status);
                //console.log(" In UpdateStagiaireData  res.data.message r_class = " + res.data.message);
                setUpdateStagiaireEmargement_api("true");
                setUpdateStagiaireEmargement_result(res.data.message);
                GetListeEmargement(mysession);
            }
            else {
                setUpdateStagiaireEmargement_api("false");
                setUpdateStagiaireEmargement_message(res.data.message);

            }

        }).catch((error) => {

            console.warn('handleClick_valide_emargement : Not good man :( mysearchtext = ' + error);
            setUpdateStagiaireEmargement_api("false");

        })

    }


    /*
    # status :  0 ==> Preinscription
    # status : 1 ==> Inscription validée
    # status : -1 ==> Inscription annulée
    """
    */
    function handleClick_accept(event, cellValues) {

        var montant = String(cellValues.row.amount);
        if (parseFloat(montant).toFixed(2) <= 0) {
            alert(" le montant de la formation est incorrect");
            return;

        }

        var nom = cellValues.row.nom;
        var email = cellValues.row.email;
        var prenom = cellValues.row.prenom;
        var opco = cellValues.row.opco;
        var modefinancement = cellValues.row.modefinancement;
        var status = "1";
        var employeur = cellValues.row.employeur;

        UpdateStagiaireData(nom, prenom, email, status, montant, opco, modefinancement, employeur);
    }

    function handleClick_update_data(event, cellValues) {

        var montant = String(cellValues.row.amount);
        var nom = cellValues.row.nom;
        var email = cellValues.row.email;
        var prenom = cellValues.row.prenom;
        var opco = cellValues.row.opco;
        var modefinancement = cellValues.row.modefinancement;
        var status = "0";
        var employeur = cellValues.row.employeur;


        UpdateStagiaireData(nom, prenom, email, status, montant, opco, modefinancement, employeur);
    }

    function handleClick_refuse(event, cellValues) {
    }

    const [submenu, setsubmenu] = useState("preinscrit");
    function submenu_preinscrit() {
        setsubmenu("preinscrit");
    }

    function submenu_inscrit() {
        setsubmenu("inscrit");
    }

    function submenu_divers() {
        setsubmenu("divers");
    }

    function submenu_emargement() {
        setsubmenu("emargement");
    }


    const [UpdateStagiaireData_api, setUpdateStagiaireData_api] = useState();
    const [UpdateStagiaireData_message, setUpdateStagiaireData_message] = useState();
    const [UpdateStagiaireData_result, setUpdateStagiaireData_result] = useState();
    function UpdateStagiaireData(nom, prenom, email, status, price, opco, modefinancement, employeur) {

        var form = new FormData();
        //form.append("token","K3cw63eKokKSbV4spjQ48SUNnfy80yrXfA");

        if (mysession.length <= 0) {
            alert(" Vous devez choisir une session");
            return;
        }
        const stored_cookie = getCookie('tokenmysypart');
        form.append("token", stored_cookie);
        form.append("class_internal_url", internal_url);
        form.append("session_id", mysession);
        form.append("nom", nom);
        form.append("prenom", prenom);
        form.append("email", email);
        form.append("employeur", employeur);
        form.append("status", status);
        form.append("price", price);
        form.append("opco", opco);
        form.append("modefinancement", modefinancement);

        var myurl = process.env.REACT_APP_API_URL + "myclass/api/UpdateStagiairetoClass/";

        axios.post(myurl, form).then(res => {

            if (res.data.status != "false") {
                //console.log(" In UpdateStagiaireData  res.data.status = " + res.data.status);
                //console.log(" In UpdateStagiaireData  res.data.message r_class = " + res.data.message);
                setUpdateStagiaireData_api("true");
                setUpdateStagiaireData_result(res.data.message);
                GetListePreinscrit(mysession);
                GetListeInscrit(mysession);
            }
            else {
                setUpdateStagiaireData_api("false");
                setUpdateStagiaireData_message(res.data.message);

            }

        }).catch((error) => {

            console.warn('UpdateStagiaireData : Not good man :( mysearchtext = ' + error);
            setUpdateStagiaireData_api("false");

        })
    }


    //const [GetCurrentClass_session, setGetCurrentClass_session] = useState();

    //const data = [];
    //const [mydata, setmydata] = useState([]);


    const [GetCurrentClass_api, setGetCurrentClass_api] = useState();
    const [GetCurrentClass_message, setGetCurrentClass_message] = useState();
    const [GetCurrentClass_result, setGetCurrentClass_result] = useState();
    function GetCurrentClass(event) {
        var form = new FormData();
        //form.append("token","K3cw63eKokKSbV4spjQ48SUNnfy80yrXfA");
        const stored_cookie = getCookie('tokenmysypart');
        form.append("token", stored_cookie);
        form.append("internal_url", internal_url);

        var myurl = process.env.REACT_APP_API_URL + "myclass/api/get_partner_class/";

        axios.post(myurl, form).then(res => {

            if (res.data.status != "false") {
                //console.log(" In GetCurrentClass  res.data.status = " + res.data.status);
                //console.log(" In GetCurrentClass  res.data.message r_class = " + res.data.message);
                setGetCurrentClass_api("true");
                setGetCurrentClass_result(res.data.message);
                var mylocaltraining = JSON.parse(res.data.message);
                document.getElementsByName("external_code")[0].value = mylocaltraining.external_code;
                document.getElementsByName("title")[0].value = mylocaltraining.title;
                setclasstitle(mylocaltraining.title);

                document.getElementsByName("trainer")[0].value = mylocaltraining.trainer;
                setmydistance(mylocaltraining.presentiel.distantiel);
                setmypresence(mylocaltraining.presentiel.presentiel);
                if (mylocaltraining.published)
                    setmypublished(mylocaltraining.published);
                else
                    setmypublished("0");

                if (mylocaltraining.price)
                    document.getElementsByName("price")[0].value = mylocaltraining.price;
                else
                    document.getElementsByName("price")[0].value = "";


                if (mylocaltraining.domaine) {
                    document.getElementsByName("domaine")[0].value = mylocaltraining.domaine;
                }
                else
                    document.getElementsByName("domaine")[0].value = "";

                if (mylocaltraining.duration)
                    document.getElementsByName("duree")[0].value = mylocaltraining.duration;
                else
                    document.getElementsByName("duree")[0].value = "";

                document.getElementsByName("metier")[0].value = "";
                if (mylocaltraining.metier)
                    document.getElementsByName("metier")[0].value = mylocaltraining.metier;

                document.getElementsByName("note")[0].value = "";
                if (mylocaltraining.note)
                    document.getElementsByName("note")[0].value = mylocaltraining.note;



                document.getElementsByName("url")[0].value = "";
                if (mylocaltraining.url)
                    document.getElementsByName("url")[0].value = mylocaltraining.url;

            }
            else {
                setGetCurrentClass_api("false");
                setGetCurrentClass_message(res.data.message);
            }

        }).catch((error) => {
            console.warn('Not good man :( mysearchtext = ', error);
            setGetCurrentClass_api("false");
            //setmyApimyApiMessage("")
        })
    }

    const [selectionModel, setSelectionModel] = React.useState([]);
    const [rowss, setRows] = useState([]);
    const [GetListePreinscrit_api, setGetListePreinscrit_api] = useState();
    const [GetListePreinscrit_meassage, setGetListePreinscrit_meassage] = useState();
    const [GetListePreinscrit_result, setGetListePreinscrit_result] = useState([])
    function GetListePreinscrit(localsessionid) {

        var form = new FormData();
        //form.append("token","K3cw63eKokKSbV4spjQ48SUNnfy80yrXfA");
        const stored_cookie = getCookie('tokenmysypart');
        form.append("token", stored_cookie);
        form.append("class_internal_url", internal_url);
        form.append("session_id", localsessionid);
        form.append("status", "0");

        var myurl = process.env.REACT_APP_API_URL + "myclass/api/GetAllClassStagiaire/";

        fetch(myurl,
            {
                method: 'POST',
                body: form,
            })
            .then((data) => data.json())
            .then((data) => {
                //console.log('Success:', data['message'], "data['status'] = ", data['status']);
                setGetListePreinscrit_result(data['message']);
                setRows(data['message']);
                if (String(data['status']) === String("false")) {
                    //console.log("erreur rrrr:" + data['status'])
                    setGetListePreinscrit_api("false");

                }
                else {
                    setGetListePreinscrit_api("true");

                }

            }).catch((error) => {
                console.error('Error:', error);
                setGetListePreinscrit_api("false");
            });

    }

    /* Envoi de l'envoi de l'email de confirmation de la validation de l'inscription */
    function handleClick_resend_conf_mail(event, cellValues) {
        var email = cellValues.row.email;
        alert(" confirmation email = " + email);
        SendInscriptionConfirmation(email);
    }


    const [SendInscriptionConfirmation_api, setSendInscriptionConfirmation_api] = useState();
    const [SendInscriptionConfirmation_message, setSendInscriptionConfirmation_message] = useState();
    const [SendInscriptionConfirmation_result, setSendInscriptionConfirmation_result] = useState();
    function SendInscriptionConfirmation(email) {

        var form = new FormData();
        //form.append("token","K3cw63eKokKSbV4spjQ48SUNnfy80yrXfA");

        if (mysession.length <= 0) {
            alert(" Vous devez choisir une session");
            return;
        }
        const stored_cookie = getCookie('tokenmysypart');
        form.append("token", stored_cookie);
        form.append("class_internal_url", internal_url);
        form.append("session_id", mysession);
        form.append("email", email);


        var myurl = process.env.REACT_APP_API_URL + "myclass/api/SendInscriptionConfirmation/";

        axios.post(myurl, form).then(res => {

            if (res.data.status != "false") {
                //console.log(" In UpdateStagiaireData  res.data.status = " + res.data.status);
                //console.log(" In UpdateStagiaireData  res.data.message r_class = " + res.data.message);
                setSendInscriptionConfirmation_api("true");
                setSendInscriptionConfirmation_result(res.data.message);

            }
            else {
                setSendInscriptionConfirmation_api("false");
                setSendInscriptionConfirmation_message(res.data.message);

            }

        }).catch((error) => {

            console.warn('SendInscriptionConfirmation : Not good man :( mysearchtext = ' + error);
            setSendInscriptionConfirmation_api("false");

        })
    }

    /* Recuperation de la liste des inscrits */
    const [selectionModel_insc, setSelectionModel_insc] = React.useState([]);
    const [rowss_insc, setRows_insc] = useState([]);
    const [GetListePreinscrit_insc_api, setGetListePreinscrit_insc_api] = useState();
    const [GetListePreinscrit_insc_meassage, setGetListePreinscrit_insc_meassage] = useState();
    const [GetListePreinscrit_insc_result, setGetListePreinscrit_insc_result] = useState([])
    function GetListeInscrit(localsessionid) {

        var form = new FormData();
        //form.append("token","K3cw63eKokKSbV4spjQ48SUNnfy80yrXfA");
        const stored_cookie = getCookie('tokenmysypart');
        form.append("token", stored_cookie);
        form.append("class_internal_url", internal_url);
        form.append("session_id", localsessionid);
        form.append("status", "1");

        var myurl = process.env.REACT_APP_API_URL + "myclass/api/GetAllClassStagiaire/";

        fetch(myurl,
            {
                method: 'POST',
                body: form,
            })
            .then((data) => data.json())
            .then((data) => {
                //console.log(' GetListeInscrit :  Success:', data['message'], "data['status'] = ", data['status']);
                setGetListePreinscrit_insc_result(data['message']);
                setRows_insc(data['message']);
                if (String(data['status']) === String("false")) {
                    //console.log("erreur rrrr:" + data['status'])
                    setGetListePreinscrit_insc_api("false");

                }
                else {
                    setGetListePreinscrit_insc_api("true");

                }

            }).catch((error) => {
                console.error('Error:', error);
                setGetListePreinscrit_insc_api("false");
            });

    }

    /* Recuperation de la liste d'emargement */
    const [selectionModel_emarg, setSelectionModel_emarg] = React.useState([]);
    const [rowss_emarg, setRows_emarg] = useState([]);
    const [GetListePreinscrit_emarg_api, setGetListePreinscrit_emarg_api] = useState();
    const [GetListePreinscrit_emarg_meassage, setGetListePreinscrit_emarg_meassage] = useState();
    const [GetListePreinscrit_emarg_result, setGetListePreinscrit_emarg_result] = useState([])
    function GetListeEmargement(localsessionid) {

        var form = new FormData();
        //form.append("token","K3cw63eKokKSbV4spjQ48SUNnfy80yrXfA");
        const stored_cookie = getCookie('tokenmysypart');
        form.append("token", stored_cookie);
        form.append("class_internal_url", internal_url);
        form.append("session_id", localsessionid);

        var myurl = process.env.REACT_APP_API_URL + "myclass/api/GetTableauEmargement/";

        fetch(myurl,
            {
                method: 'POST',
                body: form,
            })
            .then((data) => data.json())
            .then((data) => {
                //console.log('Success:', data['message'], "data['status'] = ", data['status']);
                setGetListePreinscrit_emarg_result(data['message']);
                setRows_emarg(data['message']);
                if (String(data['status']) === String("false")) {
                    //console.log("erreur rrrr:" + data['status'])
                    setGetListePreinscrit_emarg_api("false");

                }
                else {
                    setGetListePreinscrit_emarg_api("true");

                }

            }).catch((error) => {
                console.error('Error:', error);
                setGetListePreinscrit_emarg_api("false");
            });

    }



    useEffect(() => {
        GetCurrentClass();

        window.scrollTo(0, 0);

    }, []);

    const [mysession, setmysession] = useState("");
    const [allmysession_info, setallmysession_info] = useState("");
    const [selectedsession_date_du, setselectedsession_date_du] = useState(new Date());
    const [selectedsession_date_au, setselectedsession_date_au] = useState(new Date());
    function handleChangeSession(event) {

        setsessionChanged(false);
        clearSessionFields();

        var tab_date = [];

        setmysession(event.target.value);
        GetListePreinscrit(event.target.value);
        GetListeInscrit(event.target.value);
        GetListeEmargement(event.target.value);

        var el = document.getElementById('session_liste');
        var text = el.options[el.selectedIndex].innerHTML;
        setallmysession_info(text);

        // Recuperation de l'adresse
        const words_adresse = text.split(' à');
        if (words_adresse.length === 2) {
            var regex = /^[0-9]{2}[\/][0-9]{2}[\/][0-9]{4}$/g;
            const words = text.split(' ');
            //Iterate array
            words.forEach(
                function (date) {

                    if (regex.test(date))
                        //console.log(date + " => "+regex.test(date));
                        tab_date.push(date)
                });

            //alert("words_adresse[1] = "+words_adresse[1].trim());
            const words_adresse2 = String(words_adresse[1]).trim().split(' ');
            //console.log("words_adresse2  = ",words_adresse2);
            var taille = words_adresse2.length;
            var CP = words_adresse2[words_adresse2.length - 1]
            var ville = words_adresse2[words_adresse2.length - 2]

            var local_adress = ""
            var i = 0;
            while (i < words_adresse2.length - 2) {
                local_adress = local_adress + " " + words_adresse2[i]
                i = i + 1;

            }
            //console.log(" CP = ",CP+"  ville = ",ville+"  local_adress = ",local_adress);
            document.getElementsByName("adresse")[0].value = local_adress;
            document.getElementsByName("ville")[0].value = ville;
            document.getElementsByName("code_postal")[0].value = CP;

        }

        if (tab_date.length === 2) {
            var date_du = new Date(moment(tab_date[0], "DD/MM/YYYY")).setHours(8, 0, 0);
            var date_au = new Date(moment(tab_date[1], "DD/MM/YYYY")).setHours(18, 0, 0);
            setSessionstartDate(date_du);
            setSessionendDate(date_au)
        }

        GetCurrentSession(event.target.value);
    };

    const [CreateListEmargement_api, setCreateListEmargement_api] = useState();
    const [CreateListEmargement_message, setCreateListEmargement_message] = useState();
    const [CreateListEmargement_result, setCreateListEmargement_result] = useState();
    function CreateListEmargement() {
        var form = new FormData();
        //form.append("token","K3cw63eKokKSbV4spjQ48SUNnfy80yrXfA");
        const stored_cookie = getCookie('tokenmysypart');
        form.append("token", stored_cookie);
        form.append("class_internal_url", internal_url);
        form.append("session_id", mysession);

        //alert(" mysession = "+mysession);

        var myurl = process.env.REACT_APP_API_URL + "myclass/api/CreateTableauEmargement/";

        axios.post(myurl, form).then(res => {

            if (String(res.data.status) !== "false") {
                //console.log(" In UpdateStagiaireData  res.data.status = " + res.data.status);
                //console.log(" In UpdateStagiaireData  res.data.message r_class = " + res.data.message);
                setCreateListEmargement_api("true");
                setCreateListEmargement_result(res.data.message);
                GetListeEmargement(mysession);

            }
            else {
                setCreateListEmargement_api("false");
                setCreateListEmargement_message(res.data.message);
            }

        }).catch((error) => {

            console.warn('CreateListEmargement : Not good man :( mysearchtext = ' + error);
            setCreateListEmargement_api("false");

        })
    }


    const [CreateSessionFormation_api, setCreateSessionFormation_api] = useState();
    const [CreateSessionFormation_message, setCreateSessionFormation_message] = useState();
    const [CreateSessionFormation_result, setCreateSessionFormation_result] = useState();
    function CreateSessionFormation() {
        var form = new FormData();
        var nb_participant = "0";

        if (mysession.length <= 0) {
            alert(" Vous devez choisir une session");
            return;
        }

        nb_participant = ""
        if (document.getElementById("nb_participant") && document.getElementById("nb_participant").value != ""){
            nb_participant = document.getElementById("nb_participant").value;
        }
        if( nb_participant.trim() == ""){
            alert(" Le nombre de participants est obligatoire");
            return;
        }

        if( String(document.getElementById("sessiondatedebutinscription").value).trim() == ""  ){
            alert(" La date de debut des inscriptions est obligatoire");
            return;
        }

        if( String(document.getElementById("sessiondatefininscription").value).trim() == ""  ){
            alert(" La date de fin des inscriptions est obligatoire");
            return;
        }

        var adress = ""
        if (document.getElementById("adresse") && document.getElementById("adresse").value != "")
            adress = document.getElementById("adresse").value;

        var codepostal = ""
        if (document.getElementById("code_postal") && document.getElementById("code_postal").value != "")
            codepostal = document.getElementById("code_postal").value;


        var ville = ""
        if (document.getElementById("ville") && document.getElementById("ville").value != "")
            ville = document.getElementById("ville").value;

        //form.append("token","K3cw63eKokKSbV4spjQ48SUNnfy80yrXfA");
        const stored_cookie = getCookie('tokenmysypart');
        form.append("token", stored_cookie);
        form.append("class_internal_url", internal_url);
        form.append("formation_session_id", mysession);
        form.append("date_debut", format(SessionstartDate, 'dd/MM/yyyy kk:mm:ss'));
        form.append("date_fin", format(SessionendDate, 'dd/MM/yyyy kk:mm:ss'));
        form.append("nb_participant", nb_participant);
        form.append("adresse", adress);
        form.append("code_postal", codepostal);
        form.append("ville", ville);
        form.append("session_status", sessionStatus);
        form.append("date_debut_inscription", format(SessionstartDateInscription, 'dd/MM/yyyy kk:mm:ss'));
        form.append("date_fin_inscription", format(SessionendDateInscription, 'dd/MM/yyyy kk:mm:ss'));

        var myurl = process.env.REACT_APP_API_URL + "myclass/api/Add_Update_SessionFormation/";



        axios.post(myurl, form).then(res => {

            if (String(res.data.status) !== "false") {
                //console.log(" In UpdateStagiaireData  res.data.status = " + res.data.status);
                //console.log(" In UpdateStagiaireData  res.data.message r_class = " + res.data.message);
                setCreateSessionFormation_api("true");
                setCreateSessionFormation_result(res.data.message);
                setsessionChanged(false);
                desableSessionFields();

            }
            else {
                setCreateSessionFormation_api("false");
                setCreateSessionFormation_message(res.data.message);
            }

        }).catch((error) => {

            console.warn('CreateSessionFormation : Not good man :( mysearchtext = ' + error);
            setCreateSessionFormation_api("false");

        })
    }

    const [GetCurrentSession_api, setGetCurrentSession_api] = useState();
    const [GetCurrentSession_message, setGetCurrentSession_message] = useState();
    const [GetCurrentSession_result, setGetCurrentSession_result] = useState();
    function GetCurrentSession(localsession_id) {
        var form = new FormData();
        //form.append("token","K3cw63eKokKSbV4spjQ48SUNnfy80yrXfA");
        const stored_cookie = getCookie('tokenmysypart');
        form.append("token", stored_cookie);
        form.append("class_internal_url", internal_url);
        form.append("formation_session_id", localsession_id);

        var myurl = process.env.REACT_APP_API_URL + "myclass/api/GetSessionFormation/";

        axios.post(myurl, form).then(res => {

            if (res.data.status != "false") {
                console.log(" In GetCurrentSession  res.data.status = " + res.data.status);
                console.log(" In GetCurrentSession  res.data.message r_class = " + res.data.message);
                setGetCurrentSession_api("true");
                setGetCurrentSession_result(res.data.message);
                var mylocaltraining = JSON.parse(res.data.message);


                if (mylocaltraining.date_debut) {
                    var date_du = new Date(moment(mylocaltraining.date_debut, "DD/MM/YYYY HH:mm:ss"));
                    setSessionstartDate(date_du);
                }

                if (mylocaltraining.date_fin) {
                    var date_fin = new Date(moment(mylocaltraining.date_fin, "DD/MM/YYYY HH:mm:ss"));
                    setSessionendDate(date_fin);
                }

                if (mylocaltraining.date_debut_inscription) {
                    var date_du_inscript = new Date(moment(mylocaltraining.date_debut_inscription, "DD/MM/YYYY HH:mm:ss"));
                    setSessionstartDateInscription(date_du_inscript);

                }

                if (mylocaltraining.date_fin_inscription) {
                    var date_fin_inscript = new Date(moment(mylocaltraining.date_fin_inscription, "DD/MM/YYYY HH:mm:ss"));
                    setSessionendDateInscription(date_fin_inscript);
                }



                document.getElementsByName("nb_participant")[0].value = "";
                if (mylocaltraining.nb_participant)
                    document.getElementsByName("nb_participant")[0].value = mylocaltraining.nb_participant;

                document.getElementsByName("adresse")[0].value = "";
                if (mylocaltraining.adresse)
                    document.getElementsByName("adresse")[0].value = mylocaltraining.adresse;

                document.getElementsByName("ville")[0].value = "";
                if (mylocaltraining.ville) {
                    document.getElementsByName("ville")[0].value = mylocaltraining.ville;
                }

                document.getElementsByName("code_postal")[0].value = "";
                if (mylocaltraining.code_postal)
                    document.getElementsByName("code_postal")[0].value = mylocaltraining.code_postal;


                if (String(mylocaltraining.session_status) === "true")
                    setsessionStatus(true);
                else if (String(mylocaltraining.session_status) === "false")
                    setsessionStatus(false);


            }
            else {
                setGetCurrentSession_api("false");
                setGetCurrentSession_message(res.data.message);
            }

        }).catch((error) => {
            console.warn('Not good man :( GetCurrentSession = ', error);
            setGetCurrentSession_api("false");

        })
    }


    function annuleSessionUpdate() {
        GetCurrentSession(mysession);
        setsessionChanged(false);
    }
    const [SessionstartDate, setSessionstartDate] = useState();
    const filterPassedTime_start = (time) => {
        const currentDate = new Date();
        const selectedDate = new Date(time);

        return currentDate.getTime() < selectedDate.getTime();
    };


    const [SessionendDate, setSessionendDate] = useState();
    const filterPassedTime_end = (time) => {
        const currentDate = new Date();
        const selectedDate = new Date(time);

        return currentDate.getTime() < selectedDate.getTime();
    };

    const [SessionstartDateInscription, setSessionstartDateInscription] = useState();
    const filterPassedTime_start_Inscription = (time) => {
        const currentDate = new Date();
        const selectedDate = new Date(time);

        return currentDate.getTime() < selectedDate.getTime();
    };


    const [SessionendDateInscription, setSessionendDateInscription] = useState();
    const filterPassedTime_end_Inscription = (time) => {
        const currentDate = new Date();
        const selectedDate = new Date(time);

        return currentDate.getTime() < selectedDate.getTime();
    };


    function toggleSessionStatus() {

        if (sessionStatus === true)
            setsessionStatus(false);
        else
            setsessionStatus(true);

        enableSessionFields();
        setsessionChanged(true);
    }

    let [sessionStatus, setsessionStatus] = useState(false);

    let [sessionChanged, setsessionChanged] = useState(false);

    function IssessionChanged() {
        setsessionChanged(true);
    }

    let [fields1desabled, setfields1desabled] = useState(true);

    function desableSessionFields() {

        document.getElementsByName("sessiondatedebut")[0].disabled = true;
        document.getElementsByName("sessiondatedebut")[0].style.backgroundColor = "#ECEFF1";

        document.getElementsByName("sessiondatefin")[0].disabled = true;
        document.getElementsByName("sessiondatefin")[0].style.backgroundColor = "#ECEFF1";

        document.getElementsByName("adresse")[0].disabled = true;
        document.getElementsByName("adresse")[0].style.backgroundColor = "#ECEFF1";

        document.getElementsByName("code_postal")[0].disabled = true;
        document.getElementsByName("code_postal")[0].style.backgroundColor = "#ECEFF1";

        document.getElementsByName("ville")[0].disabled = true;
        document.getElementsByName("ville")[0].style.backgroundColor = "#ECEFF1";

        document.getElementsByName("nb_participant")[0].disabled = true;
        document.getElementsByName("nb_participant")[0].style.backgroundColor = "#ECEFF1";

        document.getElementsByName("sessiondatedebutinscription")[0].disabled = true;
        document.getElementsByName("sessiondatedebutinscription")[0].style.backgroundColor = "#ECEFF1";

        document.getElementsByName("sessiondatefininscription")[0].disabled = true;
        document.getElementsByName("sessiondatefininscription")[0].style.backgroundColor = "#ECEFF1";

        setfields1desabled(true);

    }

    function enableSessionFields() {


        //setfields1desabled(true);
        document.getElementsByName("sessiondatedebut")[0].disabled = false;
        document.getElementsByName("sessiondatedebut")[0].style.backgroundColor = "#FFFFFF";

        document.getElementsByName("sessiondatefin")[0].disabled = false;
        document.getElementsByName("sessiondatefin")[0].style.backgroundColor = "#FFFFFF";

        document.getElementsByName("adresse")[0].disabled = false;
        document.getElementsByName("adresse")[0].style.backgroundColor = "#FFFFFF";

        document.getElementsByName("code_postal")[0].disabled = false;
        document.getElementsByName("code_postal")[0].style.backgroundColor = "#FFFFFF";

        document.getElementsByName("ville")[0].disabled = false;
        document.getElementsByName("ville")[0].style.backgroundColor = "#FFFFFF";

        document.getElementsByName("nb_participant")[0].disabled = false;
        document.getElementsByName("nb_participant")[0].style.backgroundColor = "#FFFFFF";

        document.getElementsByName("sessiondatedebutinscription")[0].disabled = false;
        document.getElementsByName("sessiondatedebutinscription")[0].style.backgroundColor = "#FFFFFF";

        document.getElementsByName("sessiondatefininscription")[0].disabled = false;
        document.getElementsByName("sessiondatefininscription")[0].style.backgroundColor = "#FFFFFF ";

        setfields1desabled(false);
    }

    function clearSessionFields() {
        document.getElementsByName("adresse")[0].value = "";
        document.getElementsByName("ville")[0].value = "";
        document.getElementsByName("code_postal")[0].value = "";

        document.getElementsByName("nb_participant")[0].value = "";
        setSessionstartDateInscription();
        setSessionendDateInscription();
        setSessionendDate();
        setSessionstartDate();
    }

    function DownloadListEmargement(event) {

        const stored_cookie = getCookie('tokenmysypart');

        var nom_liste_emarge = "Liste_Emargement.pdf";

        var url = process.env.REACT_APP_API_URL + "myclass/api/GerneratePDFEmargementList/" + stored_cookie + "/" + mysession + "/" + internal_url;



        axios.get(url, { responseType: 'blob', },)
            .then((res) => {
                fileDownload(res.data, nom_liste_emarge)
            })
    }


    useEffect(() => {
        desableSessionFields();
    }, [])

    const [selectedemargement, setselectedemargement] = useState([])
    function GetSelectedRowsEmargement() {

        var tab_tmp = []


        for (var i = 0; i < selectionModel_emarg.length; i++) {
            var myid = parseInt(String(selectionModel_emarg[i]));
            tab_tmp.push(JSON.parse(rowss_emarg[myid])._id);

        }
        setselectedemargement(tab_tmp);
        return tab_tmp;
    }

    const [ActionMassListEmargement_api, setActionMassListEmargement_api] = useState();
    const [ActionMassListEmargement_message, setActionMassListEmargement_message] = useState();
    const [ActionMassListEmargement_result, setActionMassListEmargement_result] = useState();
    function ActionMassListEmargement(e) {

        if( selectionModel_emarg.length <= 0 ){
            alert(" Selectionnez un enregistrement pour envoyer la demande d'emargement");
            return;
        }

        var actionenmasse = ""
        if (document.getElementById("actionmass_emarge")) {
            actionenmasse = document.getElementById("actionmass_emarge").value;
        }

        var liste_emargement_id = GetSelectedRowsEmargement();

        console.log("liste_formation = " + liste_emargement_id);

        var form = new FormData();
        //form.append("token","K3cw63eKokKSbV4spjQ48SUNnfy80yrXfA");
        const stored_cookie = getCookie('tokenmysypart');
        form.append("token", stored_cookie);
        form.append("tab_ids", liste_emargement_id);
        var myurl = process.env.REACT_APP_API_URL + "myclass/api/EmargementMail/";
        axios.post(myurl, form).then(res => {

            if (String(res.data.status) !== "false") {
                //console.log(" In UpdateStagiaireData  res.data.status = " + res.data.status);
                //console.log(" In UpdateStagiaireData  res.data.message r_class = " + res.data.message);
                setActionMassListEmargement_api("true");
                setActionMassListEmargement_result(res.data.message);
            }
            else {
                setActionMassListEmargement_api("false");
                setActionMassListEmargement_message(res.data.message);

            }

        }).catch((error) => {

            console.warn('ActionMassListEmargement : Not good man :( mysearchtext = ' + error);
            setActionMassListEmargement_api("false");

        })

        

        if (String(actionenmasse) === String("depublier")) {

            alert("depublier");
        }

        else if (String(actionenmasse) === String("publier")) {
            alert("publier");
        }

        else if (String(actionenmasse) === String("supprimer")) {
            alert("supprimer");
        }
    }

    function ConfirmInitListEmargement() {
        confirmAlert({
			message: "Confirmez la (re)initialisation de la liste d'emargement ? Toutes les confirmations seront perdues",
           
            buttons: [
                {
                    label: 'Oui',
                    onClick: () => {CreateListEmargement()}
                },
                {
                    label: 'Non',
                    onClick: () => {  return }

                }
            ],
            closeOnEscape: false,
            closeOnClickOutside: false,
            keyCodeForClose: [8, 32],
            willUnmount: () => { },
            afterClose: () => { },
            onClickOutside: () => { },
            onKeypress: () => { },
            onKeypressEscape: () => { },
        });
    }

    function ConfirmEnvoiListEmargement() {
        confirmAlert({
			message: "Confirmez l'envoi des demandes d'emargement aux participants",
           
            buttons: [
                {
                    label: 'Oui',
                    onClick: () => {ActionMassListEmargement()}
                },
                {
                    label: 'Non',
                    onClick: () => {  return }

                }
            ],
            closeOnEscape: false,
            closeOnClickOutside: false,
            keyCodeForClose: [8, 32],
            willUnmount: () => { },
            afterClose: () => { },
            onClickOutside: () => { },
            onKeypress: () => { },
            onKeypressEscape: () => { },
        });
    }
    return (
        <div className='gestionadministrative'>
            <Helmet>
                <title>Partenaires editeurs formations</title>
                <meta name="description" content="backoffice partenaire editeurs formation" />
                <meta name="robots" content="index,follow" />
            </Helmet>
            <Header />

            <div className="div_mobile">

                <div className="zone_data">
                    <h3> Gestion Administrative de  {classtitle}
                    </h3>


                    <div className="div_row session_data" style={{ "border": "None" }}>
                        <div className="training_data">
                            <div className="training_caract">
                                <TextField
                                    required
                                    name="external_code"
                                    label="Code"
                                    InputLabelProps={{
                                        shrink: true,
                                    }}
                                    disabled={true}
                                    className="disabled_style"

                                />
                            </div>

                            <div className="training_caract">
                                <TextField
                                    required
                                    name="title"
                                    label="Titre"
                                    InputLabelProps={{
                                        shrink: true,
                                    }}
                                    disabled={true}
                                    className="disabled_style"
                                />
                            </div>

                            <div className="training_caract">
                                <TextField
                                    required
                                    name="trainer"
                                    label="Formateur"
                                    InputLabelProps={{
                                        shrink: true,
                                    }}
                                    disabled={true}
                                    className="disabled_style"
                                />
                            </div>

                            <div className="training_caract">
                                <TextField
                                    name="published"
                                    select
                                    label="Publié"
                                    value={mypublished}
                                    InputLabelProps={{
                                        shrink: true,
                                    }}

                                    disabled={true}
                                    className="disabled_style"
                                >

                                </TextField>
                            </div>

                            <div className="training_caract">
                                <TextField
                                    name="presentiel"
                                    select
                                    label="Présentiel"
                                    value={mypresence}
                                    InputLabelProps={{
                                        shrink: true,
                                    }}

                                    disabled={true}
                                    className="disabled_style"
                                >

                                </TextField>
                            </div>

                            <div className="training_caract">
                                <TextField
                                    name="distentiel"
                                    select
                                    label="A distance"
                                    value={mydistance}
                                    InputLabelProps={{
                                        shrink: true,
                                    }}

                                    disabled={true}
                                    className="disabled_style"
                                >

                                </TextField>
                            </div>

                            <div className="training_caract">
                                <TextField
                                    required
                                    name="domaine"
                                    label="Domaine"
                                    InputLabelProps={{
                                        shrink: true,
                                    }}
                                    disabled={true}
                                    className="disabled_style"
                                />
                            </div>

                            <div className="training_caract">
                                <TextField
                                    name="price"
                                    label="Prix"
                                    type="number"
                                    InputLabelProps={{
                                        shrink: true,
                                    }}
                                    disabled={true}
                                    className="disabled_style"
                                />
                            </div>

                            <div className="training_caract">

                                <TextField
                                    name="duree"
                                    label="Duree (jour)"
                                    type="number"
                                    InputLabelProps={{
                                        shrink: true,
                                    }}
                                    disabled={true}
                                    className="disabled_style"
                                />
                            </div>

                            <div className="training_caract">
                                <TextField
                                    name="url"
                                    label="site web"
                                    type="text"
                                    InputLabelProps={{
                                        shrink: true,
                                    }}
                                    disabled={true}
                                    className="disabled_style"
                                />
                            </div>

                            <div className="training_caract">
                                <TextField
                                    name="metier"
                                    label="metier"
                                    type="text"
                                    InputLabelProps={{
                                        shrink: true,
                                    }}
                                    disabled={true}
                                    className="disabled_style"
                                />
                            </div>

                            <div className="training_caract">
                                <TextField
                                    name="note"
                                    id="note"
                                    label="Note"
                                    type="number"
                                    InputLabelProps={{
                                        shrink: true,
                                    }}
                                    inputProps={{ min: "1", max: "5", step: "0.5" }}
                                    disabled={true}
                                    className="disabled_style"
                                />
                            </div>


                        </div>
                    </div>
                    <div className="div_row" style={{ "border": "None" }}>
                        <div className="div_row" style={{ "border": "None" }}>

                            <div className="div_row" style={{ "border": "None" }}>
                                &nbsp; <br />
                            </div>

                            <div className="div_row_gauche">
                                Choisir une session
                            </div>

                            <div className="div_row_droite">


                                {GetCurrentClass_result &&
                                    GetCurrentClass_result.map((formation) => (

                                        <div style={{
                                            display: "inline-block", width: "100%",
                                            textAlign: "right", paddingLeft: "0.5rem"
                                        }} >

                                            <select id="session_liste" value={mysession} onChange={handleChangeSession} className="selectsession">
                                                <option value="">Choisir</option>
                                                {
                                                    JSON.parse(formation).datelieu.map((session) => <option value={session.session_id}>


                                                        {session.date_du} - {session.date_au} à {session.adresse} {session.ville} {session.code_postal}


                                                    </option>)
                                                }
                                            </select>

                                        </div>
                                    ))}

                            </div>

                            <div className="div_row" style={{ "border": "None" }}>

                                <div className="session_data" onChange={IssessionChanged}>

                                    {mysession && <div className="div_row" style={{ "border": "None" }}>

                                        <div className="session_caract" style={{ "float": "right" }}>
                                            <nav onChange={toggleSessionStatus} id="toggleSwitchNav" name="toggleSwitchNav">
                                                <ToggleSwitch label="Activation Session " id="toggleSwitch" name="toggleSwitch" checked={sessionStatus} />
                                            </nav>

                                        </div>
                                    </div>}


                                    <div className="session_caract">
                                        Date Debut
                                        <DatePicker
                                            name="sessiondatedebut"
                                            id="sessiondatedebut"
                                            selected={SessionstartDate}
                                            onChange={(date) => setSessionstartDate(date)}
                                            showTimeSelect
                                            filterTime={filterPassedTime_start}
                                            dateFormat="dd/MM/yyyy HH:mm"
                                            className="disabled_style"
                                            locale='fr-FR'

                                        />
                                    </div>


                                    <div className="session_caract"> Date Fin
                                        <DatePicker
                                            name="sessiondatefin"
                                            id="sessiondatefin"
                                            selected={SessionendDate}
                                            onChange={(date) => setSessionendDate(date)}
                                            showTimeSelect
                                            filterTime={filterPassedTime_end}
                                            dateFormat="dd/MM/yyyy HH:mm"
                                            className="disabled_style"
                                        />
                                    </div>

                                    <div className="session_caract"> Adresse<br />
                                        <TextField
                                            sx={{ '& legend': { display: 'none' }, '& fieldset': { top: 0 }, }}
                                            required
                                            name="adresse"
                                            id="adresse"

                                            InputLabelProps={{
                                                shrink: true,
                                            }}
                                            disabled={false}
                                            className="disabled_style"

                                        />
                                    </div>
                                    <div className="session_caract"> Code postal<br />
                                        <TextField
                                            sx={{ '& legend': { display: 'none' }, '& fieldset': { top: 0 }, }}
                                            required
                                            name="code_postal"
                                            id="code_postal"

                                            InputLabelProps={{
                                                shrink: true,
                                            }}
                                            disabled={false}
                                            className="disabled_style"

                                        />
                                    </div>
                                    <div className="session_caract"> Ville<br />
                                        <TextField
                                            sx={{ '& legend': { display: 'none' }, '& fieldset': { top: 0 }, }}
                                            required
                                            name="ville"
                                            id="ville"

                                            InputLabelProps={{
                                                shrink: true,
                                            }}
                                            disabled={false}
                                            className="disabled_style"

                                        />
                                    </div>

                                    <div className="session_caract"> Nombre participants *<br />
                                        <TextField sx={{ '& legend': { display: 'none' }, '& fieldset': { top: 0 }, }}
                                            required
                                            name="nb_participant"
                                            id="nb_participant"
                                            type="number"
                                            InputLabelProps={{
                                                shrink: true,
                                            }}
                                            inputProps={{ min: "1", max: "1000", step: "1" }}
                                            disabled={false}
                                            className="disabled_style"
                                        />
                                    </div>
                                    <div className="div_row" style={{ "border": "None" }}>
                                        <div className="session_caract"> Date Debut des inscriptions *
                                            <DatePicker
                                                required
                                                name="sessiondatedebutinscription"
                                                id="sessiondatedebutinscription"
                                                selected={SessionstartDateInscription}
                                                onChange={(date) => setSessionstartDateInscription(date)}
                                                showTimeSelect
                                                //filterTime={filterPassedTime_start}
                                                dateFormat="dd/MM/yyyy HH:mm"
                                                className="disabled_style"
                                                locale='fr-FR'

                                            />
                                        </div>


                                        <div className="session_caract"> Date Fin des inscriptions *
                                            <DatePicker
                                                required
                                                name="sessiondatefininscription"
                                                id="sessiondatefininscription"
                                                selected={SessionendDateInscription}
                                                onChange={(date) => setSessionendDateInscription(date)}
                                                showTimeSelect
                                                //filterTime={filterPassedTime_end}
                                                dateFormat="dd/MM/yyyy HH:mm"
                                                className="disabled_style"
                                            />
                                        </div>
                                    </div>


                                    <div className="div_row" style={{ "border": "None" }}>
                                        &nbsp;
                                    </div>


                                    {sessionChanged && <div className="div_row" style={{ "border": "None", "color": "orange", "textAlign": "center" }}>
                                        /!\ Pensez à enregistrer les modifications
                                    </div>}

                                    {!sessionChanged && String(CreateSessionFormation_api) === "true" &&
                                        <div className="div_row okUpdateData" style={{ "textAlign": "center" }}>
                                            La session de formation à été bien mise à jour.
                                        </div>}

                                    {!sessionChanged && String(CreateSessionFormation_api) === "false" &&
                                        <div className="div_row koUpdateData" style={{ "textAlign": "center" }}>
                                            {CreateSessionFormation_message}
                                        </div>}


                                    {<div className="div_row" style={{ "border": "None", "color": "orange", "textAlign": "center" }}>

                                        <div className="div_row_gauche" style={{ "textAlign": 'left', 'marginLeft': '15px' }}>

                                            {sessionChanged &&
                                                <Button variant="contained" color="success" className="div_row22 btn_modif" onClick={CreateSessionFormation}>Enregistrer les modifications
                                                </Button>}
                                        </div>

                                        <div className="div_row_droite" style={{ "textAlign": 'right', 'marginRight': '15px' }}>
                                            {!sessionChanged &&
                                                <Button variant="contained" color="success" className="div_row22 btn_modif" onClick={enableSessionFields}>Editer
                                                </Button>}

                                            {sessionChanged &&
                                                <Button variant="contained" color="success" className="div_row22 btn_modif" onClick={annuleSessionUpdate}>Annuler les modifications
                                                </Button>}


                                        </div>

                                    </div>}


                                </div>


                            </div>

                        </div>
                    </div>

                    <div className="div_row" style={{ "border": "None" }}>
                        {String(UpdateStagiaireData_api) === "true" && <div className="okUpdateData"> la mise à jour a été correctement faite</div>}

                        {String(UpdateStagiaireData_api) === "false" && <div className="koUpdateData"> {UpdateStagiaireData_message}</div>}
                        { }

                        <div style={{ "textAlign": "left", "float": "left", "width": "100%" }}>
                            <Button variant="outlined" onClick={submenu_preinscrit} className="detail_class_submenu" id='menu_preinscrit' name='menu_preinscrit'>Preinscription</Button>
                            <Button variant="outlined" onClick={submenu_inscrit} className="detail_class_submenu" id='menu_inscrit' name='menu_inscrit'>Inscription</Button>
                            <Button variant="outlined" onClick={submenu_emargement} className="detail_class_submenu" id='menu_divers' name='menu_divers'>Liste émargement</Button>
                            <Button variant="outlined" onClick={submenu_divers} className="detail_class_submenu" id='menu_divers' name='menu_divers'>Divers</Button>

                            {/*<hr className="hr_height" />*/}

                            <div className="session_data">
                                {String(submenu) === String("preinscrit") && <div className="detail_class_submenu_data" style={{ "border": "None" }}>

                                    <div style={{ height: 500, width: '100%' }}>
                                        <DataGrid
                                            checkboxSelection
                                            onSelectionModelChange={(newSelectionModel) => {
                                                setSelectionModel(newSelectionModel);
                                                //console.log("ch selected--" + newSelectionModel);
                                            }}
                                            selectionModel={selectionModel}

                                            localeText={frFR.components.MuiDataGrid.defaultProps.localeText}
                                            rows={rowss.map((item, index) => (
                                                {
                                                    id: index,
                                                    nom: JSON.parse(item).nom,
                                                    prenom: JSON.parse(item).prenom,
                                                    employeur: JSON.parse(item).employeur,
                                                    email: JSON.parse(item).email,
                                                    amount: JSON.parse(item).price,
                                                    opco: JSON.parse(item).opco,
                                                    modefinancement: JSON.parse(item).modefinancement,


                                                }
                                            ))}

                                            columns={columns_preinscrit}
                                            pageSize={10}
                                            className="datagridclass"

                                            rowsPerPageOptions={[10]}
                                            disableSelectionOnClick
                                            components={{
                                                Toolbar: GridToolbar,
                                            }}


                                        />


                                        <br />
                                        {/* <Button variant="contained" onClick={GetAllClass_new}>Contained</Button>*/}
                                    </div>

                                </div>}

                                {String(submenu) === String("inscrit") && <div className="detail_class_submenu_data" style={{ "border": "None" }}>

                                    <div style={{ height: 500, width: '100%' }}>
                                        <DataGrid
                                            checkboxSelection
                                            onSelectionModelChange={(newSelectionModel_insc) => {
                                                setSelectionModel(newSelectionModel_insc);
                                                //console.log("ch selected--" + newSelectionModel);
                                            }}
                                            selectionModel={selectionModel_insc}



                                            localeText={frFR.components.MuiDataGrid.defaultProps.localeText}
                                            rows={rowss_insc.map((item, index) => (
                                                {
                                                    id: index,
                                                    nom: JSON.parse(item).nom,
                                                    prenom: JSON.parse(item).prenom,
                                                    employeur: JSON.parse(item).employeur,
                                                    email: JSON.parse(item).email,
                                                    amount: JSON.parse(item).price,
                                                    opco: JSON.parse(item).opco,
                                                    modefinancement: JSON.parse(item).modefinancement,


                                                }
                                            ))}

                                            columns={columns_inscrit}
                                            pageSize={10}
                                            className="datagridclass"

                                            rowsPerPageOptions={[10]}
                                            disableSelectionOnClick
                                            components={{
                                                Toolbar: GridToolbar,
                                            }}


                                        />


                                        <br />
                                        {/* <Button variant="contained" onClick={GetAllClass_new}>Contained</Button>*/}
                                    </div>
                                </div>}


                                {String(submenu) === String("emargement") && <div className="detail_class_submenu_data" style={{ "border": "None" }}>


                                    <div className="div_row" style={{"textAlign":"right","marginTop":"0.5rem"}}>
                                    <Button className="bton_emarge" onClick={ConfirmInitListEmargement}>Initaliser la liste emargement</Button>
                                            <Button className="bton_emarge" onClick={DownloadListEmargement}>Imprimer la liste emargement</Button>
                                            <Button className="bton_emarge" onClick={ConfirmEnvoiListEmargement}>Envoyer les demandes d'emargement</Button><br />

                                        </div>

                                    {String(CreateListEmargement_api) === "true" && <div className="okUpdateData">
                                        La liste d'emargement a été créée
                                    </div>}

                                    {String(CreateListEmargement_api) === "false" && <div className="koUpdateData">
                                        {CreateListEmargement_message}
                                    </div>}

                                    {String(ActionMassListEmargement_api) === "true" && <div className="okUpdateData">
                                        Les demandes d'emargement ont bien été envoyées
                                    </div>}

                                    {String(ActionMassListEmargement_api) === "false" && <div className="koUpdateData">
                                        {CreateListEmargement_message}
                                    </div>}



                                    <div style={{ height: 500, width: '100%' }}>
                                        <DataGrid
                                            checkboxSelection
                                            onSelectionModelChange={(newSelectionModel_emarg) => {
                                                setSelectionModel_emarg(newSelectionModel_emarg);
                                                console.log("ch selected--" + newSelectionModel_emarg);

                                            }}

                                            selectionModel={selectionModel_emarg}
                                            localeText={frFR.components.MuiDataGrid.defaultProps.localeText}
                                            rows={rowss_emarg.map((item, index) => (
                                                {
                                                    id: index,
                                                    nom: JSON.parse(item).nom,
                                                    prenom: JSON.parse(item).prenom,
                                                    email: JSON.parse(item).email,
                                                    date: JSON.parse(item).date,
                                                    matin: JSON.parse(item).matin,
                                                    apresmidi: JSON.parse(item).apresmidi,

                                                }
                                            ))}

                                            columns={columns_list_emargement}
                                            pageSize={10}
                                            className="datagridclass"

                                            rowsPerPageOptions={[10]}
                                            disableSelectionOnClick
                                            components={{
                                                Toolbar: GridToolbar,
                                            }}


                                        />


                                        <br />
                                        <Button className="bton_emarge" onClick={ActionMassListEmargement}>Envoyer les demandes d'emargement</Button><br />



                                    </div>
                                </div>}


                                {String(submenu) === String("divers") && <div className="detail_class_submenu_data" style={{ "border": "None" }}>
                                    divers
                                </div>}
                            </div>

                        </div>
                    </div>
                </div>
                <div className="pieddepage">
                    <Footer />
                </div>


            </div>
        </div >
    );
}
export default GestionAdministrative;
