import React, { useState, useEffect, } from "react";
import { useForm } from "react-hook-form";
import { Button, } from "reactstrap";
import axios from "axios";
import Box from '@mui/material/Box';
import InputLabel from '@mui/material/InputLabel';
import InputAdornment from '@mui/material/InputAdornment';
import FormControl from '@mui/material/FormControl';
import TextField from '@mui/material/TextField';
import AccountCircle from '@mui/icons-material/AccountCircle';
import moment from "moment";
import { getCookie } from 'react-use-cookie';

function UpdateUserGoals(props) {

    //alert(" UpdateUserGoals "+props.name_obj);

    const [fields1desabled, setfields1desabled] = useState(true);
    const url = process.env.REACT_APP_API_URL + "myclass/api/add_update_user_objectif/";


    const [defaultdate, setdefaultdate] = useState(new Date().setDate(new Date().getDate() + 10));
    const [mindate, setmindate] = useState(new Date().setDate(new Date().getDate() + 10));

    useEffect(() => {

        getGolData();
        window.scrollTo(0, 0);
    }, [props.name_obj]);

    function cleanField() {
        document.getElementsByName("name")[0].value = "";
        document.getElementById("description").value = "";
        document.getElementsByName("date_souhaite")[0].value = { defaultdate };
        document.getElementsByName("domaine")[0].value = "";
        document.getElementsByName("niveau")[0].value = "";
    }

    const [recorddata_api, setrecorddata_api] = useState();
    const [recorddata_api_message, setrecorddata_api_message] = useState();
    const [recorddata_api_result, setrecorddata_api_result] = useState([]);

    function RecordData() {
        const formData = new FormData();
        const url = process.env.REACT_APP_API_URL + "myclass/api/add_update_user_objectif/";

        var name = document.getElementsByName("name")[0].value;
        var description = document.getElementsByName("description")[0].value;
        var date_souhaite = document.getElementsByName("date_souhaite")[0].value;
        var domaine = document.getElementsByName("domaine")[0].value;
        var niveau = document.getElementsByName("niveau")[0].value;

        const stored_cookie = getCookie('tokenmysych');

        formData.append('token', stored_cookie);
        formData.append('name', name);
        formData.append('description', description);
        formData.append('date_souhaite', date_souhaite);
        formData.append('domaine', domaine);
        formData.append('niveau', niveau);

        fetch(
            url,
            {
                method: 'POST',
                body: formData,
            }
        )
            .then((response) => response.json())
            .then((result) => {
                console.log('Success:', result['message'], "result['status'] = ", result['status']);
                if (String(result['status']) === String("true")) {
                    setrecorddata_api("true");
                    setrecorddata_api_result(result['message'])

                }
                else {
                    setrecorddata_api("false");
                    setrecorddata_api_message(result['message']);
                }
            })
            .catch((error) => {
                console.error('Error:', error);
                setrecorddata_api("false");
            });


    };


    const [getGolData_api, setgetGolData_api] = useState();
    const [getGolData_api_message, setgetGolData_api_message] = useState();
    const [getGolData_api_result, setgetGolData_api_result] = useState([]);
    function getGolData() {

        cleanField();


        const formData = new FormData();
        const url = process.env.REACT_APP_API_URL + "myclass/api/get_user_objectif/";

        const stored_cookie = getCookie('tokenmysych');
        formData.append('token', stored_cookie);

        var name = props.name_obj;
        formData.append('name', name);
        //alert( "stored_user = "+stored_user);

        axios.post(url, formData).then(res => {
            if (String(res.data.status) === String("true")) {
                //console.log(" In getGolData  res.data.status = " + res.data.status);
                //console.log(" In getGolData  res.data.message = " + res.data.message);
                setgetGolData_api("true");

                var mylocalobj = JSON.parse(res.data.message);
                if (mylocalobj) {

                    if (mylocalobj.name) {
                        document.getElementsByName("name")[0].value = mylocalobj.name;
                        document.getElementsByName("name")[0].disabled = true;
                        document.getElementsByName("name")[0].style.backgroundColor = "#ECEFF1";
                    }

                    if (mylocalobj.description) {
                        document.getElementById("description").value = mylocalobj.description;
                        //document.getElementById("description").disabled = true;
                        //document.getElementById("description").style.backgroundColor = "#ECEFF1";
                    }

                    if (mylocalobj.domaine) {
                        document.getElementsByName("domaine")[0].value = mylocalobj.domaine;
                        document.getElementsByName("domaine")[0].disabled = true;
                        document.getElementsByName("domaine")[0].style.backgroundColor = "#ECEFF1";
                    }

                    if (mylocalobj.date_souhaite) {
                        //alert("mylocalobj.date_souhaite = "+mylocalobj.date_souhaite);
                        var al = moment(mylocalobj.date_souhaite).format('YYYY-DD-MM');
                        //alert(" AL = "+al);
                        document.getElementsByName("date_souhaite")[0].value = al;
                        //document.getElementsByName("date_souhaite")[0].disabled = true;
                        //document.getElementsByName("date_souhaite")[0].style.backgroundColor = "#ECEFF1";
                    }

                    if (mylocalobj.domaine) {
                        document.getElementsByName("domaine")[0].value = mylocalobj.domaine;
                        document.getElementsByName("domaine")[0].disabled = true;
                        document.getElementsByName("domaine")[0].style.backgroundColor = "#ECEFF1";
                    }

                    if (mylocalobj.niveau) {
                        document.getElementsByName("niveau")[0].value = mylocalobj.date_souhaite;
                        document.getElementsByName("niveau")[0].disabled = true;
                        document.getElementsByName("niveau")[0].style.backgroundColor = "#ECEFF1";
                    }




                } else {
                    //console.log(" In test  res.data.status = " + res.data.status);
                    //console.log(" In test  res.data.message = " + res.data.message);

                }
            }
            else {
                setgetGolData_api("true");
                setgetGolData_api_message(res.data.message);
            }


        }).catch((error) => {
            console.warn('getGolData : Not good man :( mysearchtext = ');
            setgetGolData_api("false");

        })
    }

    function updateBox() {
       setfields1desabled(false);
    }


    return (
        <div className="updateusergoals">
            <div className="div_row">
                {String(getGolData_api) === String("false") && <div className="koUpdateData"> Impossible d'afficher le detail de l'objectif </div>}

                <Box alignItems="left" sx={{ '& > :not(style)': { m: 1 }, width: '100%', }}
                  onChange={updateBox} >

                    <TextField
                        required
                        label="Nom"
                        name="name"
                        className="texte_area"
                        sx={{ m: 1, width: '48%' }}
                        InputProps={{
                            startAdornment: (
                                <InputAdornment position="start">
                                    <AccountCircle />
                                </InputAdornment>
                            ),
                        }}
                        variant="standard"
                    />
                    <TextField
                        name="domaine"
                        label="Domaine"
                        className="texte_area"
                        sx={{ m: 1, width: '48%' }}
                        InputProps={{
                            startAdornment: (
                                <InputAdornment position="start">
                                    <AccountCircle />
                                </InputAdornment>
                            ),
                        }}
                        variant="standard"
                    />


                    <TextField
                        name="niveau"
                        label="Niveau"
                        className="texte_area"
                        sx={{ m: 1, width: '48%' }}
                        InputProps={{
                            startAdornment: (
                                <InputAdornment position="start">
                                    <AccountCircle />
                                </InputAdornment>
                            ),
                        }}
                        variant="standard"
                    />

                    <TextField
                        type="date"
                        name="date_souhaite"
                        label="Date de validation"
                        className="texte_area"
                        sx={{ m: 1, width: '48%' }}
                        defaultValue={moment(defaultdate).format('YYYY-MM-DD')}
                        inputProps={{ min: { mindate } }}

                    />
                    <br />

                    <TextField
                        id="description"
                        name="description"
                        label="Description"
                        multiline
                        rows={3}
                        maxRows={10}
                        className="texte_area"
                        sx={{ m: 1, width: '48%' }}

                    />

                    <div className="div_row22">
                        {fields1desabled == false && <div className="div_row">
                            <div className="div_row_gauche">
                                <Button variant="contained" color="success" className="div_row22 btn_enreg " onClick={RecordData}>Enregister</Button>
                            </div>
                            <div className="div_row_droite">
                                <Button variant="contained" color="success" className="div_row22 btn_modif" onClick={"desablefield1"}>Annuler</Button>
                            </div>
                        </div>
                        }
                        {fields1desabled == true &&
                            <Button variant="contained" color="success" className="div_row22 btn_modif" onClick={"enablefieds1"}>Modifier</Button>
                        }

                    </div>
                </Box>
            </div>


        </div>

    );
}
export default UpdateUserGoals;